<?php
namespace DieMedialen\DmSimplecalendar\ViewHelpers;
/***************************************************************
 *  Copyright notice
 *  (c) 2014-2015 Kai Ratzeburg <hello@kai-ratzeburg.de>, Die Medialen
 *  (c) 2014-2015 Salvatore Eckel <salvatore.eckel@diemedialen.de>, Die Medialen
 ***************************************************************/
/**
 * TranslateDateViewHelper
 *
 * @package dm_simplecalendar
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 */
class TranslateDateViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {
    
    /**
     * Render Monthname.
     * 
     * @param \DateTime $dateTime
     * @param int $fullName
     * @param string $type
     * @return string
     */
    public function render(\DateTime $dateTime, $fullName, $type) {
        if(empty($type)) {
            return;
        }

        $translationPrefix = '';
        $dateName = '';

        switch($type) {
            case \DieMedialen\DmSimplecalendar\Domain\Model\ViewCalendar::$modeMonth:
                $dateName = $dateTime->format('F');
                $translationPrefix = 'date.month.';
                break;
            case \DieMedialen\DmSimplecalendar\Domain\Model\ViewCalendar::$modeWeek:
                $sonarFix = 'sonar';
                unset($sonarFix);    
                break;
            case \DieMedialen\DmSimplecalendar\Domain\Model\ViewCalendar::$modeDay:
                $dateName = $dateTime->format('D');
                $translationPrefix = 'date.weekday.';
                break;
            default:
                break;
        }

        if(!empty($translationPrefix) && !empty($dateName)) {
            $translationKey = $translationPrefix . ($fullName == 1 ? 'full.' : 'short.') . $dateName;
            return \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate($translationKey, 'DmSimplecalendar') . $this->renderChildren();
        }
        else {
            return $this->renderChildren();
        }
    }
}
